// Copyright (c) 2012 Morten Bakkedal
// This code is published under the MIT License.

using System;

using FuncLib.Functions;

namespace FuncLib.Optimization
{
	[Serializable]
	public class OptimizerResult : IOptimizerResult
	{
		public OptimizerResult(bool status, IPoint optimalPoint, double optimalValue)
		{
			Status = status;
			OptimalPoint = optimalPoint;
			OptimalValue = optimalValue;
		}

		public bool Status
		{
			get;
			private set;
		}

		public IPoint OptimalPoint
		{
			get;
			private set;
		}

		public double OptimalValue
		{
			get;
			private set;
		}
	}
}
